
class Vector(object):
    """Because for some damn reason pygame.math doesn't exist for me"""
    def __init__(self, x=0.0, y=0.0, tuple=None):
        self.x = x
        self.y = y
        if(tuple):
            self.x, self.y = tuple
    
    def __add__(self, other):
        return Vector(self.x + other.x, self.y + other.y)

    def __sub__(self, other):
        return Vector(self.x - other.x, self.y - other.y)

    def __iadd__(self, other):
        self.x += other.x
        self.y += other.y
        return self

    def __mul__(self, scalar):
        return Vector(self.x * scalar, self.y * scalar)
    
    def __repr__(self):
        return "Vector(x=%0.2f, y=%0.2f)" % (self.x, self.y)

    def as_tuple(self):
        return (self.x, self.y)
    
    def as_int_tuple(self):
        return (int(self.x), int(self.y))

    def dist2(self, other):
        """Distance squared to the other vector"""
        dx = self.x - other.x
        dy = self.y - other.y
        return dx*dx + dy* dy

    def dup(self):
        return Vector(self.x, self.y)

